#include <bits/stdc++.h>

#define REP(i, n) for(int i = 0; i < n; ++i)

using namespace std;

typedef long long ll;
typedef pair<int, int> ii;
typedef pair<ll, ii> edge;

int n, m;

vector<edge> e;
vector<int> p;

int find(int x){
	if(p[x] == x) return x;
	return p[x] = find(p[x]);
}

int main(){
	cin >> n >> m;

	int u, v; ll b;

	REP(i, n){
		cin >> b;
		e.push_back({b,{0,i+1}});
	}

	REP(i, m){
		cin >> u >> v >> b;
		e.push_back({b,{u,v}});
	}

	p.resize(n+1);
	REP(i, n+1) p[i]=i;

	ll res = 0;
	sort(e.begin(), e.end());

	for(auto x : e){
		int p1 = find(x.second.first);
		int p2 = find(x.second.second);
		if(p1 == p2) continue;
		p[p1] = p2;
		res+=x.first;
	}

	cout << res << endl;


}